

//+------------------------------------------------------------------+
//|                                        VSA NoSupply-NoDem&&.mq4 |
//|                               Copyright  2007, Vladimir Ignatov |
//|                                   http://www.vladimirignatov.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Vladimir Ignatov"
#property link      "http://www.vladimirignatov.com"

//+------------------------------------------------------------------+
//|                                                       VSAN_3.mq4 |
//|                             for MT-4                          AP |
//|                             2008.10.              ekr-ap@mail.ru |
//+------------------------------------------------------------------+
//#property copyright "AP"
//#property link      "ekr-ap@mail.ru"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


#property  indicator_buffers 1
#property  indicator_color1  Silver
#property  indicator_color2  Red
/*
extern int periodMA=14;
extern int methodMA=0;
extern int priceMA=0;
*/



extern string comment.="parametrs of StdDev of Volume";
extern int periodMA=14; //for StdDev of Volume
extern int methodMA=0;
extern int priceMA =0;
extern string comment="Adjust pframetrs of text on bars chart";
extern int ShiftDS=20; //shift for place of text Demaind/Suppli  on Chart
extern int ShiftSQ=20; //shift for place of text Squad  on Chart
extern color DScolorUpper=RoyalBlue;
extern color DScolorDown= Red;
extern color SQcolorUpper=Aqua;
extern color SQcolorDown= Magenta;
extern string SquatU=  "SQuatU__";
extern string SquatD=  "SQuatD__";
extern string NoDemand="NoDemand__";
extern string NoSupply="NoSupply__";
extern int  SizeText =8;
extern int  AngleText=90;

double MA[],StdDev[],Vol[];
double shDS,shSQ;
int init()
  {

     IndicatorBuffers(3);
     SetIndexBuffer(0,StdDev);
     SetIndexStyle(0,DRAW_NONE);
     
     SetIndexBuffer(1,MA);
     SetIndexStyle(1,DRAW_NONE);
     
     SetIndexBuffer(2,Vol);
     SetIndexStyle(2,DRAW_NONE);
     
     
   shDS=ShiftDS*Point;
   shSQ=ShiftSQ*Point;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   datetime t;
   string name;
   for(int i=0;i<Bars;i++)
   {
          t=Time[i];
          name = "NDS_" + t;
          if(ObjectFind(name) >= 0) ObjectDelete(name);
          name = "Suppl_" + t;
          if(ObjectFind(name) >= 0) ObjectDelete(name);
   }
return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,j,counted_bars=IndicatorCounted();
//----
   int limit=Bars-counted_bars;
   
   
   
double VolAve,HV,SHV,UHV,EHV,r;
 

double O,H,H_1,Hp1,Hp2,Hp3,H_L,H_L_1;


double L,L_1,Lp1,Lp2,Lp3;

double C,C_1,C_2,Cp1,Cp2,Cp3;

double V,V_1,V_2,V_3,Vp1,Vp2;

bool NoDemand[100],NoSupply[100],SquatU[100],SquatD[100];
//,NoDemand1,NoDemand2,NoDemand3,NoDemand4,NoDemand5,NoDemand6,NoDemand7,NoDemand8,NoDemand9,NoDemand10,
 //    NoDemand11,NoDemand12,NoDemand13,NoDemand14;
//*************************

   double s,r2;
   
   
   for(i=0;i<limit;i++) Vol[i]=Volume[i];
   
   for(i=0;i<limit;i++) MA[i]=iMAOnArray(Vol,Bars,periodMA,0,methodMA,i);
   
   for(i=0;i<limit;i++)
   {
     s=0;
     for(j=0;j<periodMA;j++) 
                    {
                    r=Volume[i+j]-MA[i];
                    s+=r*r;
                    }
   StdDev[i]=MathSqrt(s/periodMA);   
   }

//*************************
     
     
     for(i=limit;i>1;i--)
     {
O=Open[i];
H=High[i]; //H
H_1=High[i-1]; //H_1
Hp1=High[i+1]; //Hp1
Hp2=High[i+2]; //Hp2
Hp3=High[i+3]; //H>=Hp3/
H_L_1=High[i-1]-Low[i-1]; //H_L_1
H_L=High[i]-Low[i];//H_L_1


L=Low[i]; //L
L_1=Low[i-1];//L_1
Lp1=Low[i+1];//Lp1
Lp2=Low[i+2];//Lp2
Lp3=Low[i+3];//Lp3

C=Close[i]; //C
C_1=Close[i-1]; //C_1 
C_2=Close[i-2]; //C_2 
Cp1=Close[i+1];//Cp1
Cp2=Close[i+2];//Cp2 
Cp3=Close[i+2];//Cp3

V=Volume[i];
V_1=Volume[i-1];//V<V_1
V_2=Volume[i-2];//V_2
V_3=Volume[i-3];//V_3
Vp1=Volume[i+1];//Vp1
Vp2=Volume[i+2];//Vp2

//r=iStdDevOnArray(volume,endvol,30,0,0,endvol-1);
//VolAve=iMAOnArray(Volume,Bars,30,0,0,i);


//VolAve=iCustom(NULL,0,"StdDevVolume",periodMA,methodMA,priceMA,i);

VolAve=StdDev[i];
HV=VolAve+r;
SHV=HV+r;
UHV=SHV+r;
EHV=UHV+r;



NoDemand[0]=H>H_1 && L>=L_1 && H_L<H_L_1 && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[0]=L<L_1 && H<=H_1 && H_L<H_L_1 && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[1]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[1]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[2]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[2]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[3]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[3]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[4]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[4]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[5]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>C_1 && C==Cp1&& C==Cp2 && C>Cp3 && H>=Hp1 && H>=Hp2 && H>=Hp3 && V<V_1&& V<V_2;
NoSupply[5]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==L && C<C_1 && C==Cp1&& C==Cp2 && C<Cp3 && L<=Lp1 && L<=Lp2 && L<=Lp3 && V<V_1&& V<V_2;

NoDemand[6]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C==Cp2 && C>Cp3 && H>=Hp1 && H>=Hp2 && H>=Hp3 && V<V_1&& V<V_2 && NoDemand[5]==0;
NoSupply[6]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C==Cp2 && C<Cp3 && L<=Lp1 && L<=Lp2 && L<=Lp3 && V<V_1&& V<V_2 && NoSupply[5]==0;

NoDemand[7]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>C_1 && C==Cp1&& C==Cp2 && C>Cp3 && H>=Hp1 && H>=Hp2 && H>=Hp3 && V<V_1&& V<V_2 && NoDemand[5]==0;
NoSupply[7]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==H && C<C_1 && C==Cp1&& C==Cp2 && C<Cp3 && L<=Lp1 && L<=Lp2 && L<=Lp3 && V<V_1&& V<V_2 && NoSupply[5]==0;

NoDemand[8]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C==O && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[8]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C==O && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[9]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[9]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[10]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[10]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[11]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[11]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[12]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C==O && C==H && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[12]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C==O && C==L && C>C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[13]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && NoDemand[12]==0;
NoSupply[13]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && NoSupply[12]==0;

NoDemand[14]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C==O && C==L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && NoDemand[12]==0;
NoSupply[14]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C==O && C==H && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && NoSupply[12]==0;

NoDemand[15]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[15]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[16]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[16]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[17]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[17]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[18]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[18]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[19]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[19]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[20]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>C_1 && C==Cp1&& C==Cp2 && C>Cp3 && H>=Hp1 && H>=Hp2 && H>=Hp3 && V<V_1&& V<V_2;
NoSupply[20]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C<C_1 && C==Cp1&& C==Cp2 && C<Cp3 && L<=Lp1 && L<=Lp2 && L<=Lp3 && V<V_1&& V<V_2;

NoDemand[21]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C==Cp2 && C>Cp3 && H>=Hp1 && H>=Hp2 && H>=Hp3 && V<V_1&& V<V_2 && NoDemand[20]==0;
NoSupply[21]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C==Cp2 && C<Cp3 && L<=Lp1 && L<=Lp2 && L<=Lp3 && V<V_1&& V<V_2 && NoSupply[20]==0;

NoDemand[22]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>C_1 && C==Cp1&& C==Cp2 && C>Cp3 && H>=Hp1 && H>=Hp2 && H>=Hp3 && V<V_1&& V<V_2 && NoDemand[20]==0;
NoSupply[22]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C<C_1 && C==Cp1&& C==Cp2 && C<Cp3 && L<=Lp1 && L<=Lp2 && L<=Lp3 && V<V_1&& V<V_2 && NoSupply[20]==0;

NoDemand[23]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[23]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[24]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C!=O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[24]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C!=O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[25]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[25]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[26]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==H && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2;
NoSupply[26]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2;

NoDemand[27]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && NoDemand[26]==0;
NoSupply[27]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && NoSupply[26]==0;

NoDemand[28]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[28]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[29]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[29]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[30]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2;
NoSupply[30]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2;

NoDemand[31]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C==C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[31]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==H && C==C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[32]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C==C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && C_1>C_2 && NoDemand[34]==0;
NoSupply[32]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C==C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && C_1<C_2 && NoSupply[34]==0;

NoDemand[33]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C==O && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[33]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C==O && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[34]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==(H_L*0.5)+L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[34]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==(H_L*0.5)+L && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[35]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[35]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==H && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[36]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[36]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[37]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[37]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[38]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[38]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[39]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[39]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[4]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C==C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[40]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C==C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[41]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C==C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && C_1>C_2 && NoDemand[40]==0;
NoSupply[41]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C==C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && C_1<C_2 && NoSupply[40]==0;

NoDemand[42]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==H && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[42]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==L && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[43]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2 && NoDemand[42]==0;
NoSupply[43]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2 && NoSupply[42]==0;

NoDemand[44]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==L && C==C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2 && NoDemand[42]==0;
NoSupply[44]=H<=H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==H && C==C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2 && NoSupply[42]==0;

NoDemand[45]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C<C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[45]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C>C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[46]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[46]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[47]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[47]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[48]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[48]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[49]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C<C_1 && C==Cp1&& C>Cp2 && H>=Hp1 && H>=Hp2 && V<V_1&& V<V_2 && C_1>C_2 && NoDemand[48]==0;
NoSupply[49]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==H && C>C_1 && C==Cp1&& C<Cp2 && L<=Lp1 && L<=Lp2 && V<V_1&& V<V_2 && C_1<C_2 && NoSupply[48]==0;

NoDemand[50]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C==O && C<C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[50]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C==O && C>C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[51]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[51]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[52]=H>H_1 && L>=L_1 && H_L>=H_L_1 && C!=O && C==L && C<C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V<V_2 && C_1>C_2;
NoSupply[52]=L<L_1 && H<=H_1 && H_L>=H_L_1 && C!=O && C==H && C>C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V<V_2 && C_1<C_2;

NoDemand[53]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C>C_1 && C>Cp1&& H>=Hp1 && V==V_1&& V<=V_2;
NoSupply[53]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C<C_1 && C<Cp1&& L<=Lp1 && V==V_1&& V<=V_2;

NoDemand[54]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V==V_1&& V<=V_2;
NoSupply[54]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V==V_1&& V<=V_2;

NoDemand[55]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V==V_1&& V<=V_2;
NoSupply[55]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V==V_1&& V<=V_2;

NoDemand[56]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V==V_1&& V<=V_2;
NoSupply[56]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V==V_1&& V<=V_2;

NoDemand[57]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V==V_2;
NoSupply[57]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V==V_2;

NoDemand[58]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V==V_2;
NoSupply[58]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V==V_2;

NoDemand[59]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V==V_2;
NoSupply[59]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V==V_2;

NoDemand[60]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V<V_1&& V==V_2;
NoSupply[60]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V<V_1&& V==V_2;

NoDemand[61]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>C_1 && C>Cp1&& H<Hp1 && V<V_1&& V<V_2;
NoSupply[61]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==L && C<C_1 && C<Cp1&& L>Lp1 && V<V_1&& V<V_2;

NoDemand[62]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H<Hp1 && V<V_1&& V<V_2 && NoDemand[61];
NoSupply[62]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L>Lp1 && V<V_1&& V<V_2 && NoSupply[61]==0;

NoDemand[63]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>C_1 && C>Cp1&& H<Hp1 && V<V_1&& V<V_2 && NoDemand[61]==0;
NoSupply[63]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==H && C<C_1 && C<Cp1&& L>Lp1 && V<V_1&& V<V_2 && NoSupply[61]==0;

SquatU[0]=H>H_1 && L>=L_1 && H_L<H_L_1 && V>V_1&& V>=EHV;
SquatD[0]=L<L_1 && H<=H_1 && H_L<H_L_1 && V>V_1&& V>=EHV;

SquatU[1]=H>H_1 && L>=L_1 && H_L<H_L_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<EHV && V>=UHV;
SquatD[1]=L<L_1 && H<=H_1 && H_L<H_L_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<EHV && V>=UHV;

SquatU[2]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[2]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[3]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[3]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==L && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[4]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[4]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[5]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[5]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[6]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[6]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==L && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[7]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV && SquatU[6]==0;
SquatD[7]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV && SquatD[6]==0;

SquatU[8]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV && SquatU[6]==0;
SquatD[8]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==H && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV && SquatD[6]==0;

SquatU[9]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[9]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==L && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[10]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[10]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[11]=H>H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[11]=L<L_1 && H<=H_1 && H_L<H_L_1 && C!=O && C==H && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[12]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>Cp1&& H>=Hp1 && V>V_1&& V<HV && V>=VolAve;
SquatD[12]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==L && C<Cp1&& L<=Lp1 && V>V_1&& V<HV && V>=VolAve;

SquatU[13]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>Cp1&& H>=Hp1 && V>V_1&& V<HV && V>=VolAve && SquatU[12]==0;
SquatD[13]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<Cp1&& L<=Lp1 && V>V_1&& V<HV && V>=VolAve && SquatD[12]==0;

SquatU[14]=H>H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>Cp1&& H>=Hp1 && V>V_1&& V<HV && V>=VolAve && SquatU[12]==0;
SquatD[14]=L<L_1 && H<=H_1 && H_L<H_L_1 && C==O && C==H && C<Cp1&& L<=Lp1 && V>V_1&& V<HV && V>=VolAve && SquatD[12]==0;

SquatU[15]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C>C_1 && V>V_1&& V>=EHV;
SquatD[15]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C<C_1 && V>V_1&& V>=EHV;

SquatU[16]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<EHV && V>=UHV;
SquatD[16]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<EHV && V>=UHV;

SquatU[17]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[17]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[18]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[18]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[19]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[19]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[20]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[20]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[21]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=SHV;
SquatD[21]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=SHV;

SquatU[22]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV && SquatU[21]==0;
SquatD[22]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV && SquatD[21]==0;

SquatU[23]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV && SquatU[21]==0;
SquatD[23]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV && SquatD[21]==0;

SquatU[24]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[24]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[25]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[25]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[26]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<SHV && V>=HV;
SquatD[26]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C!=O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<SHV && V>=HV;

SquatU[27]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<HV && V>=VolAve;
SquatD[27]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<HV && V>=VolAve;

SquatU[28]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<HV && V>=VolAve && SquatU[27]==0;
SquatD[28]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==(H_L*0.5)+L && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<HV && V>=VolAve && SquatD[27]==0;

SquatU[29]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==L && C>C_1 && C>Cp1&& H>=Hp1 && V>V_1&& V<HV && V>=VolAve && SquatU[27]==0;
SquatD[29]=H<=H_1 && L>=L_1 && H_L<H_L_1 && C==O && C==H && C<C_1 && C<Cp1&& L<=Lp1 && V>V_1&& V<HV && V>=VolAve && SquatD[27]==0;

SquatU[30]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && V>V_1&& V>=EHV;
SquatD[30]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && V>V_1&& V>=EHV;

SquatU[31]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C>Cp1&& H>=Hp1 && V>V_1&& V<EHV && V>=UHV;
SquatD[31]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C<Cp1&& L<=Lp1 && V>V_1&& V<EHV && V>=UHV;

SquatU[32]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==H && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV;
SquatD[32]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C==L && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV;

SquatU[33]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV && SquatU[32]==0;
SquatD[33]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV && SquatD[32]==0;

SquatU[34]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==L && C>Cp1&& H>=Hp1 && V>V_1&& V<UHV && V>=SHV && SquatU[32]==0;
SquatD[34]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C==H && C<Cp1&& L<=Lp1 && V>V_1&& V<UHV && V>=SHV && SquatD[32]==0;

SquatU[35]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==H && C>Cp1&& H>=Hp1 && V>V_1&& C_1>C_2 && V<SHV && V>=VolAve;
SquatD[35]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C==L && C<Cp1&& L<=Lp1 && V>V_1&& C_1<C_2 && V<SHV && V>=VolAve;

SquatU[36]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C>Cp1&& H>=Hp1 && V>V_1&& C_1>C_2 && V<SHV && V>=VolAve && SquatU[35]==0;
SquatD[36]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C==(H_L*0.5)+L && C<Cp1&& L<=Lp1 && V>V_1&& C_1<C_2 && V<SHV && V>=VolAve && SquatD[35]==0;

SquatU[37]=H>H_1 && L>=L_1 && H_L==H_L_1 && C==O && C==L && C>Cp1&& H>=Hp1 && V>V_1&& C_1>C_2 && V<SHV && V>=VolAve && SquatU[35]==0;
SquatD[37]=L<L_1 && H<=H_1 && H_L==H_L_1 && C==O && C==H && C<Cp1&& L<=Lp1 && V>V_1&& C_1<C_2 && V<SHV && V>=VolAve && SquatD[35]==0;
   
  

   for(j=0; j<64;j++)
   {
   if(NoDemand[j])TextOutput(i, High[i]+shDS, 0, j);
   if(NoSupply[j])TextOutput(i, Low[i]-shDS,1, j);
   
   }
   
   for(j=0; j<38;j++)
   {
   if(SquatU[j])TextOutput2(i, High[i]+shSQ,0, j);
   if(SquatD[j])TextOutput2(i, Low[i]-shSQ,1, j);
   }
   
    }//for i
   
//----
   return(0);
  }
//+------------------------------------------------------------------+





void TextOutput(int i, double p, int ND, int NDN)
{
   datetime t=Time[i];
   string name = "NDS_" + t;
   if(ObjectFind(name) >= 0) ObjectDelete(name);
   
   ObjectCreate(name, OBJ_TEXT, 0, t, p);
    ObjectSet(name, OBJPROP_ANGLE, AngleText);
   
   string text;
   
   if(ND==0)
   {
      text = NoDemand + NDN;
      ObjectSetText(name, text, SizeText, "Arial Narrow", DScolorDown);
   }
   if(ND==1)
   {
      text = NoSupply + NDN;
      ObjectSetText(name, text, SizeText, "Arial Narrow", DScolorUpper);
   }
   
 
   }
   
   void TextOutput2(int i, double p, int ND, int NDN)
{
  datetime t=Time[i];
   string name = "Suppl_" + t;
   if(ObjectFind(name) >= 0) ObjectDelete(name);
   
   ObjectCreate(name, OBJ_TEXT, 0, t, p);
    ObjectSet(name, OBJPROP_ANGLE, AngleText);
   
   string text;
   
   if(ND==0)
   {
      text = SquatU + NDN;
      ObjectSetText(name, text, SizeText, "Arial Narrow", SQcolorDown);
       
   }
   
   if(ND==1)
   {
      text = SquatD + NDN;
      ObjectSetText(name, text, SizeText, "Arial Narrow", SQcolorUpper);
    
   }
   
   
   
   
}